#ifndef COMPANY
#define COMPANY
#include "orderlist.h"
#include "fileread.h"
#include "maint.h"

struct Asolution{
					  OrderListClass OrderList;
                 CarStatArray cars;
                 CarStatArray newcars;
                 maintclass maintshop;
                 cartypearray numofbuy;
                 long int totalcost1,totalcost2,totalcost;
					  };
struct rentstruct{
                 int onumber, index;
					 };
typedef rentstruct rentsetarray[maxrents];
typedef rentstruct ovlsetarray[maxservecar];

class    companyclass{
                      public:
                      void Run();

                      /*Data storage*/
                      char FileName[255],outfilename1[255],outfilename2[255],
                      outfilename3[255],outfilename4[255];
                      GlobalAttrib glob;
							 CarArray carsdata;
							 SubsArray subs;
							 filereadclass filereader;
                      /*Variable storage*/
                      Asolution bestsolution,tempsolution,tempforbuy;
      					 struct orderstruct onenode;
							 rentsetarray rentset;
							 int numrent,size;
                      char type,buytype;
                      bool buy,subsallow;

                      void Initialize(Asolution& onesolution,bool first);
                      /* Allocation heuristic */
                      void Allocate(Asolution& onesolution, rentsetarray rentset,int numrent);
                      void AllocCar(Asolution& onesolution,CarSetArray CarSet, porderstruct target);
                      void CheckFeasible(Asolution& onesolution,CarSetArray& CarSet, reqtype car,
                           int endtime,int duration);
                      int getload(int CarID,int start, int finish);
                      /* Result functions*/
                      void WriteOutput(Asolution& onesolution);
                      void ComputeCost(Asolution& onesolution);

                      /* Rent decision search member functions*/
                      /* Traces rent orders of the bestsolution*/
                      void rentdecision(Asolution& onesolution);
                      /* Generate alternative solutions and updates bestsolution*/
                      void generate(Asolution& onesolution,ovlsetarray ovlset,int numoverlap,int numrent);
                      /* Find overlapping orders*/
                      void findoverlap(Asolution& onesolution,porderstruct target,ovlsetarray& ovlset, int& numoverlap);
                      bool inreqtype(reqtype target, reqtype searchreq);                      
                      /*set the bestsolution so far*/
                      void setbest(Asolution& onesolution,Asolution& newsolution);
                      bool inrentset(porderstruct target, rentsetarray rentset, int numrent);

                      /* Buy decision functions */
                      void buydecision();
                      bool addnewcar(Asolution& onesolution, int CarType);
                      void delnewcar(Asolution& onesolution, int CarType);
                     };
#endif
